//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadSplitMergeDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"pdfsplitmerge.dll");	

	m_hinstLib = LoadLibrary(path);
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMSplitBegin = (MSplitBegin *)GetProcAddress(m_hinstLib, "MSplitBegin");
	if( pMSplitBegin == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMSplit = (MSplit *)GetProcAddress(m_hinstLib, "MSplit");
	if( pMSplit == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMSplitEnd = (MSplitEnd *)GetProcAddress(m_hinstLib, "MSplitEnd");
	if( pMSplitEnd == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMergeBegin = (MMergeBegin *)GetProcAddress(m_hinstLib, "MMergeBegin");
	if( pMMergeBegin == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMergeSetFiles = (MMergeSetFiles *)GetProcAddress(m_hinstLib, "MMergeSetFiles");
	if( pMMergeSetFiles == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMerge = (MMerge *)GetProcAddress(m_hinstLib, "MMerge");
	if( pMMerge == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMMergeEnd = (MMergeEnd *)GetProcAddress(m_hinstLib, "MMergeEnd");
	if( pMMergeEnd == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreeSplitMergeDll(); 
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreeSplitMergeDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadSplitMergeDll() == FALSE ){
		ShowMessage("Load pdfsplitmerge.dll failed!");
		return;
	}
	char infile[256];
	GetModulePath(infile,"test.pdf");
    	
	long id = pMSplitBegin(infile,NULL);
	if(id==-1){
		ShowMessage("PDF file unexist or damaged!");
		FreeSplitMergeDll();
		return;
	}
	if(id==-2){
		ShowMessage("PDF file is restricted!");
		FreeSplitMergeDll();
		return;
	}

	long mode = 1;
	char outPath[256];
	GetModulePath(outPath,"split\\");
	pMSplit(id,outPath,mode,NULL);

	pMSplitEnd(id);

	FreeSplitMergeDll();
	ShowMessage("Split finished!");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadSplitMergeDll() == FALSE ){
		ShowMessage("Load pdfsplitmerge.dll failed!");
		return;
	}
	char infile[256];
	GetModulePath(infile,"test.pdf");

	long id = pMSplitBegin(infile,NULL);
	if(id==-1){
		ShowMessage("PDF file unexist or damaged!");
		FreeSplitMergeDll();
		return;
	}
	if(id==-2){
		ShowMessage("PDF file is restricted!");
		FreeSplitMergeDll();
		return;
	}

	long mode = 2;
	char outFile[256];
	GetModulePath(outFile,"Deleted.pdf");
	pMSplit(id,outFile,mode,"3-8");

	pMSplitEnd(id);

	FreeSplitMergeDll();
	ShowMessage("Delete finished!");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
	if( LoadSplitMergeDll() == FALSE ){
		ShowMessage("Load pdfsplitmerge.dll failed!");
		return;
	}
	char infile[256];
	GetModulePath(infile,"test.pdf");
    	
	long id = pMSplitBegin(infile,NULL);
	if(id==-1){
		ShowMessage("PDF file unexist or damaged!");
		FreeSplitMergeDll();
		return;
	}
	if(id==-2){
		ShowMessage("PDF file is restricted!");
		FreeSplitMergeDll();
		return;
	}

	long mode = 3;
	char outFile[256];
	GetModulePath(outFile,"Extract.pdf");
	pMSplit(id,outFile,mode,"3-8,9,15");

	pMSplitEnd(id);

	FreeSplitMergeDll();
	ShowMessage("Extract finished!");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
	if( LoadSplitMergeDll() == FALSE ){
		ShowMessage("Load pdfsplitmerge.dll failed!");
		return;
	}
	
	long id = pMMergeBegin();
	if(id<=0){
		ShowMessage("Creat PDF file failed!");
		FreeSplitMergeDll();
		return;
	}
	char infile[256];
	GetModulePath(infile,"test.pdf");
    
	pMMergeSetFiles(id,infile,NULL,"1-3");
	pMMergeSetFiles(id,infile,NULL,"5");
	pMMergeSetFiles(id,infile,NULL,"7-9");

	long fsize=16;
	long fcolor=255;//red
	long position=2;//Top-Center
	long angle=0;
	long xoff=0;
	long yoff=0;
    long asbackground=0;
	//Stamping
	pMWatermark(id,"Merge into one pdf file",fsize,fcolor,position,angle,xoff,yoff,asbackground);

	char outFile[256];
	GetModulePath(outFile,"Merged.pdf");
	pMMerge(id,outFile);
	
	pMMergeEnd(id);

	FreeSplitMergeDll();
	ShowMessage("Merge finished!");
}
//---------------------------------------------------------------------------
 